/*
BUILD INFO:
  dir: assets/dev
  target: Open/main.js
  files: 25
*/



// file: header.js

IMPORT("ToolLib");
IMPORT("EnergyNet");
IMPORT("TileRender");
IMPORT("ChargeItem");
IMPORT("StorageInterface");

//const SugarCore = Packages.com.sugar.SugarCore.SugarCore;
var mis = [];
var mu = FileTools.ReadKeyValueFile(__dir__ + "music.json");
for (var key in mu) {
    mis.push(key);
};
/*
made by 桃乐丝 copy请注明作者
*/
if (__config__.getBool("music")) {
    var time = java.lang.System.currentTimeMillis();
    var _t = 0;
    var mic = new java.lang.Thread(new java.lang.Runnable() {
        run: function() {
            android.os.Process.setThreadPriority(android.os.Process.THREAD_PRIORITY_AUDIO);
            var me = music.playSound(mis, 0);
            me.setOnPreparedListener(function() {
                me.seekTo(0);
                me.start();
            });
            while (_t < time) {
                _t++;
                if (_t % 20 == 0) {
                    if (me && __config__.getBool("isLooping")) {
                        me.setLooping(true);
                    };
                    if (me && me.getCurrentPosition() != 0 && me.getDuration() != 1 && ((me.getCurrentPosition() >= me.getDuration()) || (me.getDuration() - me.getCurrentPosition() <= 400))) {
                        if (music.number + 1 == mis.length) {
                            me.release();
                            me = music.playSound(mis, 0);
                            me.setOnPreparedListener(function() {
                                me.seekTo(0);
                                me.start();
                            });
                        } else {
                            me.release();
                            me = music.playSound(mis, music.number + 1);
                            me.setOnPreparedListener(function() {
                                me.seekTo(0);
                                me.start();
                            });
                        };
                    };
                    time = java.lang.System.currentTimeMillis();
                };
                if (_t >= time) {
                    _t = 0;
                };
            };
        }
    });
    mic.setPriority(4);
    mic.start();
};
var SU = EnergyTypeRegistry.assureEnergyType("Su", 1.5);//SugarEnergy




// file: core/music.js

/*
made by 桃乐丝 copy请注明作者
*/
var music = {
    number: 0,
    playSound: function(name, number) {
            this.number = number;
            var media = new android.media.MediaPlayer();
            media.setAudioStreamType(android.media.AudioManager.STREAM_MUSIC);
            media.reset();
            media.setDataSource(__dir__ + "assets/music/" + name[this.number]);
            media.prepareAsync();
            return media;
    },
}




// file: core/sugar.js

var sugarRecipe = {};
Recipes.registryCandyRecipe = function(id, data, resultID, resultData) {
    sugarRecipe[id + ":" + data] = resultID + ":" + resultData;
};
Recipes.getCandyRecipeResult = function(id, data) {
    var _split = sugarRecipe[id + ":" + data];
    if (_split) {
        var id_data = _split.split(":");
        return {
            id: Number(id_data[0]),
            data: Number(id_data[1])
        };
    };
};

var burnerRecipe = {};
Recipes.registryBurnerRecipe = function(id, data, resultID, resultData) {
    burnerRecipe[id + ":" + data] = resultID + ":" + resultData;
};
Recipes.getBurnerRecipeResult = function(id, data) {
    var _split = burnerRecipe[id + ":" + data];
    if (_split) {
        var id_data = _split.split(":");
        return {
            id: Number(id_data[0]),
            data: Number(id_data[1])
        };
    };
};

var SugarCore = {
    createItem: function(id, itemName, dcr1, dcr2) {
        IDRegistry.genItemID(id);
        Item.createItem(id, itemName, dcr1, dcr2);
    },
    _ElectricNaturalRecipes: {},
    registerElectricNaturalRecipes: function(id, data, energy) {
        this._ElectricNaturalRecipes[id + ":" + data] = energy;
    },
    getElectricNaturalRecipes: function(id, data) {
        if (this._ElectricNaturalRecipes[id + ":" + data]) {
            return Number(this._ElectricNaturalRecipes[id + ":" + data]);
        };
    },
    createFoodItem: function(id, itemName, dcr1, dcr2) {
        IDRegistry.genItemID(id);
        Item.createFoodItem(id, itemName, dcr1, dcr2);
    },
    registerPrototype: function(id, Prototype) {
        ToolAPI.registerBlockMaterial(id, "stone", 1, true);
        Block.setDestroyTime(id, 3);
        TileEntity.registerPrototype(id, Prototype);
    },
    basicOutFunc: function(type, src) {
        this.data.last_energy_receive = this.data.energy_receive;
        this.data.energy_receive = 0;
        this.data.last_voltage = this.data.voltage;
        this.data.voltage = 0;
        var output = this.getEnergyLevel() * 15;
        if (this.data.energy >= output) {
            this.data.energy += src.add(output) - output;
        };
    },
    basicReceiveFunc: function(type, amount, voltage) {
        var add = Math.min(amount, this.getEnergyStorage() - this.data.energy);
        this.data.energy += add;
        this.data.energy_receive += add;
        this.data.voltage = Math.max(this.data.voltage, voltage);
        return add;
    },
    registerSUMachine: function(id, Prototype) {
        ICRender.getGroup("Sugar").add(id, -1);
        Prototype.defaultValues.energy = 0;
        Prototype.defaultValues.energy_receive = 0;
        Prototype.defaultValues.last_energy_receive = 0;
        Prototype.defaultValues.voltage = 0;
        Prototype.defaultValues.last_voltage = 0;
        Prototype.getEnergyLevel = Prototype.getEnergyLevel || function() {
            return 1;
        };;
        if (!Prototype.energyTick) {
            Prototype.energyTick = function() {
                this.data.last_energy_receive = this.data.energy_receive;
                this.data.energy_receive = 0;
                this.data.last_voltage = this.data.voltage;
                this.data.voltage = 0;
            };
        }
        Prototype.energyReceive = Prototype.energyReceive || this.basicReceiveFunc;
        this.registerPrototype(id, Prototype);
        EnergyTileRegistry.addEnergyTypeForId(id, SU);
    },
    registerSUStorage: function(id, Prototype) {
        Prototype.isEnergySource = function() {
                return true;
            };
        Prototype.energyReceive = Prototype.energyReceive || this.basicReceiveFunc;
        Prototype.energyTick = Prototype.energyTick || this.basicOutFunc;
        this.registerSUMachine(id, Prototype);
    },
    updateHeader: function(gui, text){
		var header = gui.getWindow("header");
		header.contentProvider.drawing[2].text = Translation.translate(text);
	}
};

/*
industrialCraft2
*/
var UpgradeAPI = {
    data: {},
    getUpgradeData: function(id) {
        return this.data[id];
    },
    isUpgrade: function(id) {
        return UpgradeAPI.data[id] ? true : false;
    },
    isValidUpgrade: function(id, count, data, container) {
        var upgrades = container.tileEntity.upgrades;
        var upgradeData = UpgradeAPI.getUpgradeData(id);
        if (upgradeData && (!upgrades || upgrades.indexOf(upgradeData.type) != -1)) {
            return true;
        }
        return false;
    },
    registerUpgrade: function(id, type, func) {
        this.data[id] = {
            type: type,
            func: func
        };
    },
    callUpgrade: function(item, machine, container, data) {
        var upgrades = machine.upgrades;
        var upgrade = this.getUpgradeData(item.id);
        if (upgrade && (!upgrades || upgrades.indexOf(upgrade.type) != -1)) {
            upgrade.func(item, machine, container, data);
        }
    },
    getUpgrades: function(machine, container) {
        var upgrades = [];
        for (var slotName in container.slots) {
            if (slotName.match(/Upgrade/)) {
                var slot = container.getSlot(slotName);
                if (slot.id > 0) {
                    var find = false;
                    for (var i in upgrades) {
                        var item = upgrades[i];
                        if (item.id == slot.id && item.data == slot.data) {
                            item.count += slot.count;
                            find = true;
                            break;
                        }
                    }
                    if (!find) {
                        item = {
                            id: slot.id,
                            count: slot.count,
                            data: slot.data
                        };
                        upgrades.push(item);
                    }
                }
            }
        }
        return upgrades;
    },
    executeUpgrades: function(machine) {
        var container = machine.container;
        var data = machine.data;
        var upgrades = this.getUpgrades(machine, container);
        for (var i in upgrades) {
            this.callUpgrade(upgrades[i], machine, container, data);
        }
        StorageInterface.checkHoppers(machine);
    },
}




// file: debug.js

var debugs = __config__["getBool"]("debug");
if (debugs) {
    Callback["addCallback"]("tick", function() {
        let id = Player["getCarriedItem"]()["id"];
        let data = Player["getCarriedItem"]()["data"];
        let count = Player["getCarriedItem"]()["count"];
        Game["tipMessage"]("ID-" + id + "   Data-" + data + "   Count-" + count);
    });
};




// file: tools/sugar.js

SugarCore.createItem("sugar_Sword", "Sugar Sword", {name: "sugar_sword", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_Shovel", "Sugar Shovel", {name: "sugar_shovel", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_Pickaxe", "Sugar Pickaxe", {name: "sugar_pickaxe", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_Axe", "Sugar Axe", {name: "sugar_axe", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_Hoe", "Sugar Hoe", {name: "sugar_hoe", meta: 0}, {stack: 1});
ToolAPI.addToolMaterial("SugarCubes", {durability: 224, level: 3, efficiency: 6, damage: 2, enchantability: 14});
ToolLib.setTool(ItemID.sugar_Sword, "SugarCubes", ToolType.sword);
ToolLib.setTool(ItemID.sugar_Shovel, "SugarCubes", ToolType.shovel);
ToolLib.setTool(ItemID.sugar_Pickaxe, "SugarCubes", ToolType.pickaxe);
ToolLib.setTool(ItemID.sugar_Axe, "SugarCubes", ToolType.axe);
ToolLib.setTool(ItemID.sugar_Hoe, "SugarCubes", ToolType.hoe);




// file: tools/brown_sugar.js

SugarCore.createItem("brown_sugar_Sword", "BrownSugar Sword", {name: "brown_sugar_sword", meta: 0}, {stack: 1});
SugarCore.createItem("brown_sugar_Shovel", "BrownSugar Shovel", {name: "brown_sugar_shovel", meta: 0}, {stack: 1});
SugarCore.createItem("brown_sugar_Pickaxe", "BrownSugar Pickaxe", {name: "brown_sugar_pickaxe", meta: 0}, {stack: 1});
SugarCore.createItem("brown_sugar_Axe", "BrownSugar Axe", {name: "brown_sugar_axe", meta: 0}, {stack: 1});
SugarCore.createItem("brown_sugar_Hoe", "BrownSugar Hoe", {name: "brown_sugar_hoe", meta: 0}, {stack: 1});
ToolLib.setTool(ItemID.brown_sugar_Sword, "stone", ToolType.sword);
ToolLib.setTool(ItemID.brown_sugar_Shovel, "stone", ToolType.shovel);
ToolLib.setTool(ItemID.brown_sugar_Pickaxe, "stone", ToolType.pickaxe);
ToolLib.setTool(ItemID.brown_sugar_Axe, "stone", ToolType.axe);
ToolLib.setTool(ItemID.brown_sugar_Hoe, "stone", ToolType.hoe);




// file: tools/sugar_cubes.js

SugarCore.createItem("sugar_cubes_Sword", "Sugar Sword", {name: "sugar_cubes_sword", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_cubes_Shovel", "Sugar Shovel", {name: "sugar_cubes_shovel", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_cubes_Pickaxe", "Sugar Pickaxe", {name: "sugar_cubes_pickaxe", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_cubes_Axe", "Sugar Axe", {name: "sugar_cubes_axe", meta: 0}, {stack: 1});
SugarCore.createItem("sugar_cubes_Hoe", "Sugar Hoe", {name: "sugar_cubes_hoe", meta: 0}, {stack: 1});
ToolLib.setTool(ItemID.sugar_cubes_Sword, "diamond", ToolType.sword);
ToolLib.setTool(ItemID.sugar_cubes_Shovel, "diamond", ToolType.shovel);
ToolLib.setTool(ItemID.sugar_cubes_Pickaxe, "diamond", ToolType.pickaxe);
ToolLib.setTool(ItemID.sugar_cubes_Axe, "diamond", ToolType.axe);
ToolLib.setTool(ItemID.sugar_cubes_Hoe, "diamond", ToolType.hoe);




// file: items/sugar.js

SugarCore.createItem("sugar_cubes", "Sugar Cubes", {name: "sugar_cubes", meta: 0}, {stack: 64});
SugarCore.createItem("sugar_cubes_blue", "BlueSugar Cubes", {name: "sugar_cubes_blue", meta: 0}, {stack: 64});
SugarCore.createItem("brown_sugar_cubes", "BrownSugar Cubes", {name: "brown_sugar_cubes", meta: 0}, {stack: 64});
SugarCore.createItem("brown_sugar", "BrownSugar", {name: "brown_sugar", meta: 0}, {stack: 64});
SugarCore.createItem("brown_sugar_stick", "BrownSugar Stick", {name: "brown_sugar_stick", meta: 0}, {stack: 64});
SugarCore.createItem("purple_sugar", "PurpleSugar", {name: "purple_sugar", meta: 0}, {stack: 64});
SugarCore.createItem("purple_sugar_cubes", "PurpleSugar Cubes", {name: "purple_sugar_cubes", meta: 0}, {stack: 64});
SugarCore.createFoodItem("candy_canes", "Candy Canes", {name: "candy_canes", meta: 0 }, {isTech: false, stack: 1, food: 2});
SugarCore.createItem("purple_sugar_stick", "PurpleSugar Stick", {name: "purple_sugar_stick", meta: 0}, {stack: 64});
SugarCore.createItem("blue_sugar_crystals", "BlueSugar Crystals", {name: "blue_sugar_crystals", meta: 0}, {isTech: true, stack: 1});
SugarCore.createItem("purple_sugar_crystals", "PurpleSugar Crystals", {name: "purple_sugar_crystals", meta: 0}, {isTech: true, stack: 1});
SugarCore.createFoodItem("sugar_melon", "Sugar Melon", {name: "sugar_melon", meta: 0 }, {isTech: false, stack: 64, food: 3});




// file: items/bottle.js

SugarCore.createFoodItem("sugar_bottle_0", "Sugar Tea", {name: "sugar_bottle", meta: 0 }, {isTech: false, stack: 1, food: 2});
SugarCore.createFoodItem("sugar_bottle_1", "BlueSugar Tea", {name: "sugar_bottle", meta: 1 }, {isTech: false, stack: 1, food: 8});
SugarCore.createFoodItem("brown_sugar_bottle", "BrownSugar Tea", {name: "brown_sugar_bottle", meta: 0 }, {isTech: false, stack: 1, food: 2});




// file: items/plate.js

SugarCore.createItem("brown_sugar_plate", "BrownSugar Plate", {name: "brown_sugar_plate", meta: 0}, {stack: 64});
SugarCore.createItem("purple_sugar_plate", "PurpleSugar Plate", {name: "purple_sugar_plate", meta: 0}, {stack: 64});
SugarCore.createItem("core_plate_1", "SugarCore Plate level1", {name: "core_plate_1", meta: 0}, {stack: 64});
SugarCore.createItem("core_plate_2", "SugarCore Plate level2", {name: "core_plate_2", meta: 0}, {stack: 64});




// file: blocks/sugar.js

IDRegistry.genBlockID("sugar_tile");
Block.createBlock("sugar_tile", [{name: "Sugar Tile", texture: [["sugar_tile", 0]], inCreative: true}]);
IDRegistry.genBlockID("sugar_blue_tile");
Block.createBlock("sugar_blue_tile", [{name: "BlueSugar Tile", texture: [["sugar_blue_tile", 0]], inCreative: true}]);
IDRegistry.genBlockID("brown_sugar_tile");
Block.createBlock("brown_sugar_tile", [{name: "BrownSugar Tile", texture: [["brown_sugar_tile", 0]], inCreative: true}]);




// file: blocks/furnace.js

IDRegistry.genBlockID("brown_sugar_furnace0");
Block.createBlock("brown_sugar_furnace0", [{name: "Furnace",texture: [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_off", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]],inCreative: true}]);
ToolAPI.registerBlockMaterial(BlockID["brown_sugar_furnace0"], "stone");
TileRenderer.setStandartModel(BlockID.brown_sugar_furnace0, [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_off", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]]);
TileRenderer.registerRotationModel(BlockID.brown_sugar_furnace0, 0, [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_off", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]]);
TileRenderer.registerRotationModel(BlockID.brown_sugar_furnace0, 4, [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_on", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]]);
TileRenderer.setRotationPlaceFunction(BlockID.brown_sugar_furnace0);
var FurnaceGui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Furnace(Sugar)")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 480, y: 180, bitmap: "arrow_0", scale: 3}, 
        {type: "bitmap", x: 400, y: 180, bitmap: "fire_0", scale: 4}, 
    ],
    elements: {
        "fireScale": {type: "scale", x: 400, y: 180, direction: 1, value: 0.5, bitmap: "fire_1", scale: 4},
        "arrowScale": {type: "scale", x: 480, y: 180, direction: 0, value: 0.5, bitmap: "arrow_1", scale: 3},
        "desert": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {return Recipes.getFurnaceRecipeResult(id, data) ? true : false}},
        "result": { type: "slot", x: 560, y: 170, size: 60,isValid: function(id, count, data) {return false}},
        "fuel": {type: "slot", x: 400, y: 240, isValid: function(id, count, data) {return Recipes.getFuelBurnDuration(id, data) > 0}, size: 60},
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(FurnaceGui, "糖果熔炉");
});
TileEntity.registerPrototype(BlockID.brown_sugar_furnace0, {
    defaultValues: {
        isActive: false,
        burn: 0,
        burnMax: 200,
        make: 0,
        meta: 0,
        isCreate: false,
    },
    getFuel: function(Name) {
        var fuelSlot = this.container.getSlot(Name);
        var fuel = Recipes.getFuelBurnDuration(fuelSlot.id, fuelSlot.data);
        if (fuelSlot.id == 325 && fuelSlot.data == 10) {
                fuelSlot.data = 0;
                fuelSlot.count = 1;
            } else {
                fuelSlot.count -= 1;
                this.container.validateSlot(Name);
            };
        return this.data.burnMax = this.data.burn = fuel;
    },
    tick: function() {
        var desert = this.container.getSlot("desert");
        var resultSlot = this.container.getSlot("result");
        var fuelSlot = this.container.getSlot("fuel");
        var result = Recipes.getFurnaceRecipeResult(desert.id, desert.data);
        if (result && (resultSlot.id == result.id || resultSlot.id == 0) && resultSlot.data == result.data) {
            if (this.data.burn > 0) {
                this.data.isCreate = true;
                this.data.make += 1;
                if (this.data.make == 200) {
                    resultSlot.id = result.id;
                    resultSlot.data = result.data;
                    resultSlot.count += 1;
                    desert.count -=1;
                    this.container.validateSlot("desert");
                    this.data.make = 0;
                    this.data.isCreate = false;
                };
            } else if (fuelSlot.id > 0) {
                this.getFuel("fuel");
            } else {
                this.data.make = 0;
                this.data.isCreate = false;
            };
        };
        if (this.data.burn > 0) {
            this.data.burn -= 1;
        };
        if (desert.id == 0) {
            this.data.isCreate = false;
        };
        if (!this.data.isCreate) {
            this.data.make = 0
        };
        if (this.data.burn <= 0 && !this.data.isCreate) {
            this.data.burn = this.data.make = 0;
            this.data.burnMax = 200;
        };
        this.container.setScale("arrowScale", this.data.make / 200);
        this.container.setScale("fireScale", this.data.burn / this.data.burnMax);
    },
    getGuiScreen: function() {
        return FurnaceGui;
    },
    init: function() {
        TileRenderer.mapAtCoords(this.x, this.y, this.z, this.blockID, this.data.meta + (this.data.isActive ? 4 : 0));
    },
    activate: function() {
        if (!this.data.isActive) {
            this.data.isActive = true;
            TileRenderer.mapAtCoords(this.x, this.y, this.z, this.blockID, this.data.meta + 4);
        }
    },
    deactivate: function() {
        if (this.data.isActive) {
            this.data.isActive = false;
            TileRenderer.mapAtCoords(this.x, this.y, this.z, this.blockID, this.data.meta);
        };
    },
});
StorageInterface.createInterface(BlockID.brown_sugar_furnace0, {
	slots: {
		"desert": {input: true,
	         isValidInput: function(item){
		         return Recipes.getFurnaceRecipeResult(item.id, item.data) ? true : false;
	         }
	     },
	    "fuel": {input: true,
	         isValidInput: function(item){
		         return Recipes.getFuelBurnDuration(item.id, item.data) > 0;
	         }
	     },
	    "result": {input: false}
	 }
});




// file: blocks/burn.js

Recipes.registryCandyRecipe(ItemID.sugar_cubes, 0, ItemID.brown_sugar_cubes, 0);
Recipes.registryCandyRecipe(ItemID.brown_sugar_cubes, 0, ItemID.purple_sugar_cubes, 0);
IDRegistry.genBlockID("brown_sugar_burn");
Block.createBlock("brown_sugar_burn", [{name: "Burn", texture: [["brown_sugar_furnace_top", 0], ["brown_sugar_core_top", 0], ["brown_sugar_furnace_top", 0], ["brown_sugar_furnace_top", 0], ["brown_sugar_furnace_top", 0], ["brown_sugar_furnace_top", 0]], inCreative: true}]);
var BurnGui_sugar = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Burn(Sugar)")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 480, y: 180, bitmap: "arrow_0", scale: 3}, 
        {type: "bitmap", x: 400, y: 180, bitmap: "fire_0", scale: 4}, 
    ],
    elements: {
        "fireScale": {type: "scale", x: 400, y: 180, direction: 1, value: 0.5, bitmap: "fire_1", scale: 4},
        "arrowScale": {type: "scale", x: 480, y: 180, direction: 0, value: 0.5, bitmap: "arrow_1", scale: 3},
        "desert": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {return Recipes.getCandyRecipeResult(id, data) ? true : false}},
        "result": { type: "slot", x: 560, y: 170, size: 60, isValid: function(id, count, data) {return false}},
        "fuel": {type: "slot", x: 400, y: 240, isValid: function(id, count, data) {return Recipes.getFuelBurnDuration(id, data) > 0}, size: 60},
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(BurnGui_sugar, "炼糖炉");
});
TileEntity.registerPrototype(BlockID.brown_sugar_burn, {
    defaultValues: {
        burn: 0,
        burnMax: 200,
        make: 0,
        isCreate: false,
    },
    getFuel: function (Name) {
        var fuelSlot = this.container.getSlot(Name);
        var fuel = Recipes.getFuelBurnDuration(fuelSlot.id, fuelSlot.data);
            if (fuelSlot.id == 325 && fuelSlot.data == 10) {
                fuelSlot.data = 0;
                fuelSlot.count = 1;
            } else {
                fuelSlot.count -= 1;
                this.container.validateSlot(Name);
            };
        return this.data.burnMax = this.data.burn = fuel;
    },
    tick: function() {
        var desert = this.container.getSlot("desert");
        var resultSlot = this.container.getSlot("result");
        var fuelSlot = this.container.getSlot("fuel");
        var result = Recipes.getCandyRecipeResult(desert.id, desert.data);
        if (result && (resultSlot.id == result.id || resultSlot.id == 0) && resultSlot.count < 64 && resultSlot.data == result.data) {
            if (this.data.burn > 0) {
                this.data.isCreate = true;
                this.data.make += 1;
            } else if (fuelSlot.id > 0) {
                this.getFuel("fuel");
            } else {
                this.data.make = 0;
                this.data.isCreate = false;
            };
        };
        if (this.data.burn > 0) {
            this.data.burn -= 1;
        };
        if (this.data.make == 200) {
            resultSlot.id = result.id;
            resultSlot.data = result.data;
            resultSlot.count += 1;
            desert.count -=1;
            this.container.validateSlot("desert");
            this.data.make = 0;
            this.data.isCreate = false;
        };
        if (desert.id == 0) {
            this.data.isCreate = false;
        };
        if (!this.data.isCreate) {
            this.data.make = 0
        };
        if (this.data.burn <= 0 && !this.data.isCreate) {
            this.data.burn = this.data.make = 0;
            this.data.burnMax = 200;
        };
        this.container.setScale("arrowScale", this.data.make / 200);
        this.container.setScale("fireScale", this.data.burn / this.data.burnMax);
    },
    click: function(id, count, data, coords) {
        if (World.getBlock(this.x, this.y - 1, this.z).id == BlockID.sugar_tile && World.getBlock(this.x + 1, this.y - 1, this.z).id == BlockID.brown_sugar_tile && World.getBlock(this.x - 1, this.y - 1, this.z).id == BlockID.brown_sugar_tile && World.getBlock(this.x, this.y - 1, this.z + 1).id == BlockID.brown_sugar_tile && World.getBlock(this.x, this.y - 1, this.z - 1).id == BlockID.brown_sugar_tile) {
            return false;
        } else {
            return true;
        };
    },
    getGuiScreen: function() {
        return BurnGui_sugar;
    },
});
StorageInterface.createInterface(BlockID.brown_sugar_burn, {
	slots: {
		"desert": {input: true,
	         isValidInput: function(item){
		         return Recipes.getCandyRecipeResult(item.id, item.data) ? true : false;
	         }
	     },
	    "fuel": {input: true,
	         isValidInput: function(item){
		         return Recipes.getFuelBurnDuration(item.id, item.data) > 0;
	         }
	     },
	    "result": {input: false}
	 }
});




// file: blocks/table.js

IDRegistry.genBlockID("purple_sugar_table");
Block.createBlock("purple_sugar_table", [{name: "Table", texture: [["purple_sugar_cubes_table_top", 0], ["purple_sugar_cubes_table_top", 0], ["purple_sugar_cubes_table_side", 0], ["purple_sugar_cubes_table_side", 0], ["purple_sugar_cubes_table_side", 0], ["purple_sugar_cubes_table_side", 0]], inCreative: true}]);
var render = new ICRender.CollisionShape();
var entry = render.addEntry();
entry.addBox(0.4, 0, 0.4, 0.6, 0.8, 0.6);
entry.addBox(0, 0.8, 0, 1, 1, 1);
BlockRenderer.setCustomCollisionShape(BlockID.purple_sugar_table, 0, render);
render = new ICRender.Model();
var model = BlockRenderer.Model();
model.addBox(0.4, 0, 0.4, 0.6, 0.8, 0.6, [["brown_sugar_cubes_table_side", 0]]);
model.addBox(0.3, 0, 0.3, 0.7, 0.1, 0.7, [["brown_sugar_cubes_table_side", 0]]);
model.addBox(0, 0.8, 0, 1, 1, 1, [["purple_sugar_cubes_table_top", 0]]);
render.addEntry(model);
BlockRenderer.enableCoordMapping(BlockID.purple_sugar_table, 0, render);




// file: blocks/pot.js

IDRegistry.genBlockID("brown_sugar_pot");
Block.createBlock("brown_sugar_pot", [{name: "Pot", texture: [["brown_sugar_pot_side", 0], ["brown_sugar_pot_top", 0], ["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0]], inCreative: true}]);
var render = new ICRender.CollisionShape();
var entry = render.addEntry();
entry.addBox(0, 0, 0, 1, 0.1, 1);
entry.addBox(0, 0.1, 0, 1, 0.3, 0.1);
entry.addBox(0, 0.1, 0.9, 1, 0.3, 1);
entry.addBox(0, 0.1, 0, 0.1, 0.3, 1);
entry.addBox(0.9, 0.1, 0, 1, 0.3, 1);
BlockRenderer.setCustomCollisionShape(BlockID.brown_sugar_pot, 0, render);
render = new ICRender.Model();
var model = BlockRenderer.Model();
model.addBox(0, 0, 0, 1, 0.1, 1, [["brown_sugar_pot_side", 0], ["brown_sugar_pot_top", 0], ["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0]]);
model.addBox(0, 0.1, 0, 1, 0.3, 0.1, [["brown_sugar_pot_side", 0]]);
model.addBox(0, 0.1, 0.9, 1, 0.3, 1, [["brown_sugar_pot_side", 0]]);
model.addBox(0, 0.1, 0, 0.1, 0.3, 1, [["brown_sugar_pot_side", 0]]);
model.addBox(0.9, 0.1, 0, 1, 0.3, 1, [["brown_sugar_pot_side", 0]]);
render.addEntry(model);
BlockRenderer.enableCoordMapping(BlockID.brown_sugar_pot, 0, render);
IDRegistry.genBlockID("purple_sugar_pot");
Block.createBlock("purple_sugar_pot", [{name: "Pot", texture: [["purple_sugar_pot_side", 0], ["purple_sugar_pot_top", 0], ["purple_sugar_pot_side", 0], ["purple_sugar_pot_side", 0], ["purple_sugar_pot_side", 0], ["purple_sugar_pot_side", 0]], inCreative: true}]);
var render = new ICRender.CollisionShape();
var entry = render.addEntry();
entry.addBox(0, 0, 0, 1, 0.1, 1);
entry.addBox(0, 0.1, 0, 1, 0.3, 0.1);
entry.addBox(0, 0.1, 0.9, 1, 0.3, 1);
entry.addBox(0, 0.1, 0, 0.1, 0.3, 1);
entry.addBox(0.9, 0.1, 0, 1, 0.3, 1);
BlockRenderer.setCustomCollisionShape(BlockID.purple_sugar_pot, 0, render);
render = new ICRender.Model();
var model = BlockRenderer.Model();
model.addBox(0, 0, 0, 1, 0.1, 1, [["purple_sugar_pot_side", 0], ["purple_sugar_pot_top", 0], ["purple_sugar_pot_side", 0], ["purple_sugar_pot_side", 0], ["purple_sugar_pot_side", 0], ["purple_sugar_pot_side", 0]]);
model.addBox(0, 0.1, 0, 1, 0.3, 0.1, [["purple_sugar_pot_side", 0]]);
model.addBox(0, 0.1, 0.9, 1, 0.3, 1, [["purple_sugar_pot_side", 0]]);
model.addBox(0, 0.1, 0, 0.1, 0.3, 1, [["purple_sugar_pot_side", 0]]);
model.addBox(0.9, 0.1, 0, 1, 0.3, 1, [["purple_sugar_pot_side", 0]]);
render.addEntry(model);
BlockRenderer.enableCoordMapping(BlockID.purple_sugar_pot, 0, render);
var Brown_sugar_pot_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Pot(base)")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    elements: {
        "desert": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {if (id == 338) {return true} else {return false}}},
        "textInfo1": {type: "text", x: 700, y: 152, width: 300, height: 30, text: "0％"},
        "water": {type: "slot", x: 400, y: 240, isValid: function(id, count, data) {if (id == 325 && data == 8) {return true} else {return false}}, size: 60},
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Brown_sugar_pot_Gui, "低级甘蔗培养皿");
});
var Purple_sugar_pot_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Pot(advance)")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    elements: {
        "desert": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {if (id == 338) {return true} else {return false}}},
        "textInfo1": {type: "text", x: 700, y: 152, width: 300, height: 30, text: "0％"},
        "water": {type: "slot", x: 400, y: 240, isValid: function(id, count, data) {if (id == 325 && data == 8) {return true} else {return false}}, size: 60},
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Purple_sugar_pot_Gui, "高级甘蔗培养皿");
});
TileEntity.registerPrototype(BlockID.brown_sugar_pot, {
    defaultValues: {
        make: 0,
    },
    tick: function() {
        UpgradeAPI.executeUpgrades(this);
        var desert = this.container.getSlot("desert");
        var water = this.container.getSlot("water");
        if (desert.id > 0 && desert.count + 1 <= 64 && water.id > 0) {
            this.data.make +=1;
        };
        if (this.data.make == 100) {
            desert.count +=1;
            this.data.make = 0;
        };
        if (desert.count == 64 || desert.count == 0) {
            this.data.make = 0;
        };
        this.container.setText("textInfo1", this.data.make + "％");
    },
    getGuiScreen: function() {
        return Brown_sugar_pot_Gui;
    }
});
TileEntity.registerPrototype(BlockID.purple_sugar_pot, {
    defaultValues: {
        make: 0,
    },
    tick: function() {
        UpgradeAPI.executeUpgrades(this);
        var desert = this.container.getSlot("desert");
        var water = this.container.getSlot("water");
        if (desert.id > 0 && desert.count + 1 <= 64 && water.id > 0) {
            this.data.make +=2;
        };
        if (this.data.make == 100) {
            desert.count +=1;
            this.data.make = 0;
        };
        if (desert.count == 64 || desert.count == 0) {
            this.data.make = 0;
        };
        this.container.setText("textInfo1", this.data.make + "％");
    },
    getGuiScreen: function() {
        return Purple_sugar_pot_Gui;
    }
});
StorageInterface.createInterface(BlockID.purple_sugar_pot, {
	slots: {
		"desert": {input: true,
	         isValidInput: function(item){
		         if (item.id == 338) {return true} else {return false};
	         }
	     },
	    "water": {input: true,
	         isValidInput: function(item){
		         if (itme.id == 325 && item.data == 8) {return true} else {return false};
	         }
	     }
	 }
});
StorageInterface.createInterface(BlockID.brown_sugar_pot, {
	slots: {
		"desert": {input: true,
	         isValidInput: function(item){
		         if (item.id == 338) {return true} else {return false};
	         }
	     },
	    "water": {input: true,
	         isValidInput: function(item){
		         if (itme.id == 325 && item.data == 8) {return true} else {return false};
	         }
	     }
	 }
});




// file: blocks/burner.js

Recipes.registryBurnerRecipe(ItemID.purple_sugar_crystals, 0, ItemID.core_plate_1, 0);
Recipes.registryBurnerRecipe(ItemID.brown_sugar_plate, 0, ItemID.core_plate_1, 0);
Recipes.registryBurnerRecipe(ItemID.blue_sugar_crystals, 0, ItemID.core_plate_2, 0);
Recipes.registryBurnerRecipe(ItemID.purple_sugar_plate, 0, ItemID.core_plate_2, 0);
IDRegistry.genBlockID("brown_sugar_burner");
Block.createBlock("brown_sugar_burner", [{name: "Burner", texture: [["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0], ["burner_side", 0], ["burner_side", 0], ["burner_side", 0], ["burner_side", 0]], inCreative: true}]);
var Burner_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Burner")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 480, y: 180, bitmap: "arrow_0", scale: 3}, 
        {type: "bitmap", x: 400, y: 180, bitmap: "fire_0", scale: 4}, 
    ],
    elements: {
        "arrowScale": {type: "scale", x: 480, y: 180, direction: 0, value: 0.5, bitmap: "arrow_1", scale: 3},
        "desert1": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {return Recipes.getBurnerRecipeResult(id, data) ? true : false}},
        "desert2": {type: "slot", x: 400, y: 180,  value: 0.5, size: 60, isValid: function(id, count, data) {return Recipes.getBurnerRecipeResult(id, data) ? true : false}},
        "result": { type: "slot", x: 560, y: 170, size: 60, isValid: function(id, count, data) {return false}}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Burner_Gui, "刻录机");
});
TileEntity.registerPrototype(BlockID.brown_sugar_burner, {
    defaultValues: {
        make: 0,
        isCreate: false
    },
    tick: function() {
        var desert_1 = this.container.getSlot("desert1");
        var desert_2 = this.container.getSlot("desert2");
        var resultSlot = this.container.getSlot("result");
        var result_1 = Recipes.getBurnerRecipeResult(desert_1.id, desert_1.data);
        var result_2 = Recipes.getBurnerRecipeResult(desert_2.id, desert_2.data);
        if (result_1 && result_2 && desert_1.id != desert_2.id && result_1.id == result_2.id && result_1.id != 0 && (resultSlot.id == result_1.id || resultSlot.id == 0) && resultSlot.count + 1 <= 64) {
            this.data.make +=1;
            this.data.isCreate = true;
            if (this.data.make == 200) {
                desert_1.count -=1;
                desert_2.count -=1;
                resultSlot.id = result_1.id;
                resultSlot.data = result_1.data;
                resultSlot.count +=1;
                this.data.make = 0;
                this.data.isCreate = false;
            };
        };
        if (desert_1.id == 0 || desert_2.id == 0) {
            this.data.isCreate = false;
            this.data.make = 0;
        };
        this.container.setScale("arrowScale", this.data.make / 200);
    },
    click: function(id, count, data, coords) {
        if (World.getBlock(this.x, this.y - 1, this.z).id == BlockID.purple_sugar_table) {
            return false;
        } else {
            return true;
        };
    },
    getGuiScreen: function() {
        return Burner_Gui;
    },
});
StorageInterface.createInterface(BlockID.brown_sugar_burner, {
	slots: {
		"desert1": {input: false},
	    "desert2": {input: false},
	    "result": {input: false}
	 }
});




// file: blocks/shell.js

var SPECIALTYPE = {
lightlevel: 15
};
IDRegistry.genBlockID("brown_sugar_cubes_shell");
IDRegistry.genBlockID("purple_sugar_cubes_shell");
Block.createBlock("brown_sugar_cubes_shell", [{name: "BrownSugar Shell", texture: [["brown_sugar_cubes_shell", 0]], inCreative: true}], SPECIALTYPE);
Block.createBlock("purple_sugar_cubes_shell", [{name: "PurpleSugar Shell", texture: [["purple_sugar_cubes_shell", 0]], inCreative: true}], SPECIALTYPE);




// file: blocks/wire.js

IDRegistry.genBlockID("brown_sugar_cubes_wire");
IDRegistry.genBlockID("purple_sugar_cubes_wire");
Block.createBlock("brown_sugar_cubes_wire", [{name: "BrownSugar Wire", texture: [["brown_sugar_cubes_shell", 0]], inCreative: true}], SPECIALTYPE);
Block.createBlock("purple_sugar_cubes_wire", [{name: "PurpleSugar Wire", texture: [["purple_sugar_cubes_shell", 0]], inCreative: true}], SPECIALTYPE);
TileRenderer.setupWireModel(BlockID.brown_sugar_cubes_wire, 0, 0.2, "Sugar", false);
TileRenderer.setupWireModel(BlockID.purple_sugar_cubes_wire, 0, 0.2, "Sugar", false);
SU.registerWire(BlockID.brown_sugar_cubes_wire, 128);
SU.registerWire(BlockID.purple_sugar_cubes_wire, 256);




// file: machines/storage.js

ChargeItemRegistry.registerExtraItem(ItemID.purple_sugar_crystals, "Su", 20, 1, 1, "storage", true, true);
ChargeItemRegistry.registerExtraItem(ItemID.blue_sugar_crystals, "Su", 200, 1, 1, "storage", true, true);
IDRegistry.genBlockID("sugar_storage_1");
Block.createBlock("sugar_storage_1", [{name: "Sugar Storage level1", texture: [["sugar_storage", 0]], inCreative: true}]);
var sugarStorage_1 = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Sugar Storage level1")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 530, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 530 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "slot1": {type: "slot", x: 441, y: 75, /*isValid: function(id, data) {if (}*/},
        "slot2": {type: "slot", x: 441, y: 212/*, isValid: MachineRegistry.isValidEUStorage*/},
        "textInfo1": {type: "text", x: 642, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 642, y: 172, width: 350, height: 30, text: "50000"}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(sugarStorage_1, "一级储能库");
});
SugarCore.registerSUStorage(BlockID.sugar_storage_1, {
    defaultValues: {
        meta: 0
    },
    getGuiScreen: function() {
        return sugarStorage_1;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 50000;
    },
    tick: function() {
        StorageInterface.checkHoppers(this);
        var energyStorage = this.getEnergyStorage();
        this.data.energy += ChargeItemRegistry.getEnergyFrom(this.container.getSlot("slot2"), "Su", energyStorage - this.data.energy, 1);
        this.data.energy -= ChargeItemRegistry.addEnergyTo(this.container.getSlot("slot1"), "Su", this.data.energy, 1);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    canReceiveEnergy: function(side, type) {
        return side != this.data.meta;
    },
    canExtractEnergy: function(side, type) {
        return side == this.data.meta;
    },
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.sugar_storage_1, 1, 0, extra);
    },
});
Block.registerDropFunction("sugar_storage_1", function(coords, blockID, blockData, level){
	return [];
});
StorageInterface.createInterface(BlockID.sugar_storage_1, {
	slots: {
		"slot1": {input: true},
		"slot2": {input: true}
	 }
});




// file: machines/natural.js

IDRegistry.genBlockID("electric_natural");
Block.createBlock("electric_natural", [{name: "Electric Natural", texture: [["natural_side", 0], ["natural_top", 0], ["natural_side", 0]], inCreative: true}]);
SugarCore.registerElectricNaturalRecipes(18, 0, 200);
SugarCore.registerElectricNaturalRecipes(18, 1, 200);
SugarCore.registerElectricNaturalRecipes(18, 2, 200);
SugarCore.registerElectricNaturalRecipes(18, 3, 200);
SugarCore.registerElectricNaturalRecipes(161, 0, 200);
SugarCore.registerElectricNaturalRecipes(161, 1, 200);
SugarCore.registerElectricNaturalRecipes(6, 0, 50);
SugarCore.registerElectricNaturalRecipes(6, 1, 50);
SugarCore.registerElectricNaturalRecipes(6, 2, 50);
SugarCore.registerElectricNaturalRecipes(6, 3, 50);
SugarCore.registerElectricNaturalRecipes(6, 4, 50);
SugarCore.registerElectricNaturalRecipes(6, 5, 50);
SugarCore.registerElectricNaturalRecipes(163, 0, 300);
SugarCore.registerElectricNaturalRecipes(338, 0, 350);
var Electric_Natural_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Electric Natural")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 530, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 530 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "slot1": {type: "slot", x: 441, y: 75},
        "textInfo1": {type: "text", x: 642, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 642, y: 172, width: 350, height: 30, text: "2000"}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Electric_Natural_Gui, "生态发电机");
});
SugarCore.registerSUMachine(BlockID.electric_natural, {
    defaultValues: {
        meta: 0,
        abl: 0,
        energy: 0
    },
    getGuiScreen: function() {
        return Electric_Natural_Gui;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 2000;
    },
    tick: function() {
        var desertSlot = this.container.getSlot("slot1");
        var energyStorage = this.getEnergyStorage();
        var energy = SugarCore.getElectricNaturalRecipes(desertSlot.id, desertSlot.data);
        if (energy > 0 && this.data.abl == 0) {
            this.data.abl = energy;
            desertSlot.count -= 1;
            this.container.validateSlot("slot1");
        };
        if (this.data.abl > 0 && this.data.energy + 10 <= energyStorage) {
            this.data.abl -= 10;
            this.data.energy += 10;
        };
        StorageInterface.checkHoppers(this);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    canReceiveEnergy: function(){
        return false;
    },
    isEnergySource: function() {
        return true;
    },
    energyTick: function(type, src){
		var output = Math.min(32, this.data.energy);
		this.data.energy += src.add(output) - output;
	},
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.electric_natural, 1, 0, extra);
    }
});
Block.registerDropFunction("electric_natural", function(coords, blockID, blockData, level){
	return [];
});
StorageInterface.createInterface(BlockID.electric_natural, {
	slots: {
		"slot1": {input: true}
	 }
});




// file: machines/fridge.js

IDRegistry.genBlockID("electric_fridge");
Block.createBlockWithRotation("electric_fridge", [{name: "Fridge", texture: [["fridge_side", 0], ["fridge_side", 0], ["fridge_side", 0], ["fridge_front", 0], ["fridge_side", 0], ["fridge_side", 0]], inCreative: true}]);
var Electric_Fridge_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Fridge")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 730, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 730 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "textInfo1": {type: "text", x: 842, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 842, y: 172, width: 350, height: 30, text: "2000"},
        "slot1": {type: "slot", x: 441, y: 75},
        "slot2": {type: "slot", x: 501, y: 75},
        "slot3": {type: "slot", x: 561, y: 75},
        "slot4": {type: "slot", x: 621, y: 75},
        
        "slot5": {type: "slot", x: 441, y: 135},
        "slot6": {type: "slot", x: 501, y: 135},
        "slot7": {type: "slot", x: 561, y: 135},
        "slot8": {type: "slot", x: 621, y: 135},
        
        "slot9": {type: "slot", x: 441, y: 195},
        "slot10": {type: "slot", x: 501, y: 195},
        "slot11": {type: "slot", x: 561, y: 195},
        "slot12": {type: "slot", x: 621, y: 195}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Electric_Fridge_Gui, "电冰箱");
});
SugarCore.registerSUMachine(BlockID.electric_fridge, {
    defaultValues: {
        
    },
    getGuiScreen: function() {
        return Electric_Fridge_Gui;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 2000;
    },
    tick: function() {
        var energyStorage = this.getEnergyStorage();
        StorageInterface.checkHoppers(this);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.electric_fridge, 1, 0, extra);
    }
});
Block.registerDropFunction("electric_fridge", function(coords, blockID, blockData, level){
	return [];
});




// file: machines/solar.js

IDRegistry.genBlockID("electric_solar");
Block.createBlock("electric_solar", [{name: "Electric Solar", texture: [["solar_side", 0], ["solar_top", 0], ["solar_side", 0]], inCreative: true}]);

var Electric_Solar_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Electric Solar")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 530, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 530 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "slot1": {type: "slot", x: 441, y: 75},
        "textInfo1": {type: "text", x: 642, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 642, y: 172, width: 350, height: 30, text: "2000"}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Electric_Solar_Gui, "太阳能发电机");
});
SugarCore.registerSUMachine(BlockID.electric_solar, {
    defaultValues: {
        meta: 0,
        canSeeSky: false,
        energy: 0
    },
    getGuiScreen: function() {
        return Electric_Solar_Gui;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 2000;
    },
    tick: function() {
        var desertSlot = this.container.getSlot("slot1");
        var energyStorage = this.getEnergyStorage();
        if (GenerationUtils.canSeeSky(this.x, this.y + 1, this.z) && World.getLightLevel(this.x, this.y + 1, this.z) == 15) {
            this.data.canSeeSky = true;
        } else {
            this.data.canSeeSky = false;
        };
        if (this.data.canSeeSky) {
            this.data.energy += 1;
        };
        StorageInterface.checkHoppers(this);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    canReceiveEnergy: function(){
        return false;
    },
    isEnergySource: function(){
        return true;
    },
    energyTick: function(type, src){
		var output = Math.min(32, this.data.energy);
		this.data.energy += src.add(output) - output;
	},
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.electric_solar, 1, 0, extra);
    }
});
Block.registerDropFunction("electric_solar", function(coords, blockID, blockData, level){
	return [];
});
StorageInterface.createInterface(BlockID.electric_solar, {
	slots: {
		"slot1": {input: true}
	 }
});




// file: translate.js

function translateAll() {
    let ZN = FileTools["ReadKeyValueFile"](__dir__ + "/lang/zh_CN.lang", "=");
    let color = FileTools["ReadKeyValueFile"](__dir__ + "textColor.json")["color"];
    for (var key in ZN) {
        Translation["addTranslation"](
            key, {
                zh: color + ZN[key]
            }
        );
    };
};
translateAll();




// file: recipe.js

Callback.addCallback("PreLoaded", function(){
Recipes.addFurnace(338, ItemID.brown_sugar, 0);
Recipes.addShaped({id: ItemID.sugar_cubes, count: 1, data: 0}, ["aax","aax","xxx"], ["a", 353, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_cubes, count: 1, data: 0}, ["aax","abx","xxx"], ["a", ItemID.brown_sugar, 0, "b", 260, 0]);
Recipes.addShaped({id: ItemID.sugar_cubes_blue, count: 1, data: 0}, ["aaa","aba","aaa"], ["a", ItemID.sugar_cubes, 0, "b", 264, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_stick, count: 4, data: 0}, ["axx","axx","xxx"], ["a", ItemID.brown_sugar_cubes, 0]);
Recipes.addShaped({id: ItemID.purple_sugar_stick, count: 4, data: 0}, ["axx","axx","xxx"], ["a", ItemID.purple_sugar_cubes, 0]);
Recipes.addShaped({id: ItemID.sugar_bottle_0, count: 1, data: 0}, ["axx","bxx","xxx"], ["a", 373, 0, "b", ItemID.sugar_cubes, 0]);
Recipes.addShaped({id: ItemID.sugar_bottle_1, count: 1, data: 0}, ["axx","bxx","xxx"], ["a", 373, 0, "b", ItemID.sugar_cubes_blue, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_bottle, count: 1, data: 0}, ["axx","bxx","xxx"], ["a", 373, 0, "b", ItemID.brown_sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_furnace0, count: 1, data: 0}, ["aaa","aba","aaa"], ["a", ItemID.brown_sugar_cubes, 0, "b", 61, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_Sword, count: 1, data: 0}, ["aba","aba","aca"], ["b", ItemID.brown_sugar_cubes, 0, "c", 280, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_Shovel, count: 1, data: 0}, ["aba","aca","aca"], ["b", ItemID.brown_sugar_cubes, 0, "c", 280, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_Pickaxe, count: 1, data: 0}, ["bbb","aca","aca"], ["b", ItemID.brown_sugar_cubes, 0, "c", 280, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_Axe, count: 1, data: 0}, ["bba","bca","aca"], ["b", ItemID.brown_sugar_cubes, 0, "c", 280, 0]);
Recipes.addShaped({id: ItemID.brown_sugar_Hoe, count: 1, data: 0}, ["bba","aca","aca"], ["b", ItemID.brown_sugar_cubes, 0, "c", 280, 0]);
Recipes.addShaped({id: ItemID.sugar_Sword, count: 1, data: 0}, ["aba","aba","aca"], ["b", ItemID.sugar_cubes, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_Shovel, count: 1, data: 0}, ["aba","aca","aca"], ["b", ItemID.sugar_cubes, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_Pickaxe, count: 1, data: 0}, ["bbb","aca","aca"], ["b", ItemID.sugar_cubes, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_Axe, count: 1, data: 0}, ["bba","bca","aca"], ["b", ItemID.sugar_cubes, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_Hoe, count: 1, data: 0}, ["bba","aca","aca"], ["b", ItemID.sugar_cubes, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_cubes_Sword, count: 1, data: 0}, ["aba","aba","aca"], ["b", ItemID.sugar_cubes_blue, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_cubes_Shovel, count: 1, data: 0}, ["aba","aca","aca"], ["b", ItemID.sugar_cubes_blue, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_cubes_Pickaxe, count: 1, data: 0}, ["bbb","aca","aca"], ["b", ItemID.sugar_cubes_blue, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_cubes_Axe, count: 1, data: 0}, ["bba","bca","aca"], ["b", ItemID.sugar_cubes_blue, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: ItemID.sugar_cubes_Hoe, count: 1, data: 0}, ["bba","aca","aca"], ["b", ItemID.sugar_cubes_blue, 0, "c", ItemID.brown_sugar_stick, 0]);
Recipes.addShaped({id: BlockID.sugar_tile, count: 1, data: 0}, ["aaa","aaa","aaa"], ["a", 353, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_tile, count: 1, data: 0}, ["aaa","aaa","aaa"], ["a", ItemID.brown_sugar, 0]);
Recipes.addShaped({id: BlockID.sugar_blue_tile, count: 1, data: 0}, ["aab","bbb","bbb"], ["a", ItemID.sugar_cubes_blue, 0]);
Recipes.addShaped({id: ItemID.purple_sugar, count: 4, data: 0}, ["bbb","bab","bbb"], ["a", ItemID.purple_sugar_cubes, 0]);
Recipes.addShaped({id: ItemID.brown_sugar, count: 4, data: 0}, ["bbb","bab","bbb"], ["a", ItemID.brown_sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_burn, count: 1, data: 0}, ["cbc","bab","cbc"], ["a", 61, 0, "b", ItemID.brown_sugar_cubes, 0, "c", ItemID.sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.purple_sugar_table, count: 1, data: 0}, ["aaa","aba","cbc"], ["a", ItemID.purple_sugar_cubes, 0, "b", ItemID.brown_sugar_cubes, 0]);
Recipes.addShaped({id: ItemID.candy_canes, count: 1, data: 0}, ["bbc","cac","cac"], ["a", ItemID.purple_sugar_cubes, 0, "b", ItemID.sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_pot, count: 1, data: 0}, ["axa","aba","aaa"], ["a", ItemID.brown_sugar_cubes, 0, "b", 12, 0]);
Recipes.addShaped({id: BlockID.purple_sugar_pot, count: 1, data: 0}, ["axa","aba","aaa"], ["a", ItemID.purple_sugar_cubes, 0, "b", 12, 0]);
Recipes.addShaped({id: ItemID.purple_sugar_crystals, count: 1, data: 0}, ["aaa","aba","aaa"], ["b", ItemID.purple_sugar_cubes, 0]);
Recipes.addShaped({id: ItemID.blue_sugar_crystals, count: 1, data: 0}, ["aaa","aba","aaa"], ["b", ItemID.sugar_cubes_blue, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_cubes_shell, count: 1, data: 0}, ["aaa","aba","aaa"], ["a", ItemID.brown_sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.purple_sugar_cubes_shell, count: 1, data: 0}, ["aaa","aba","aaa"], ["a", ItemID.purple_sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_cubes_wire, count: 1, data: 0}, ["aaa","cbc","aaa"], ["a", ItemID.brown_sugar_cubes, 0, "b", ItemID.brown_sugar, 0, "c", ItemID.purple_sugar_crystals, 0]);
Recipes.addShaped({id: BlockID.purple_sugar_cubes_wire, count: 1, data: 0}, ["aaa","cbc","aaa"], ["a", ItemID.purple_sugar_cubes, 0, "b", ItemID.purple_sugar, 0, "c", ItemID.purple_sugar_crystals, 0]);
Recipes.addShaped({id: BlockID.electric_fridge, count: 1, data: 0}, ["aaa","cbc","aaa"], ["a", ItemID.sugar_cubes, 0, "b", BlockID.brown_sugar_cubes_shell, 0, "c", ItemID.brown_sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.electric_natural, count: 1, data: 0}, ["aaa","cbc","aaa"], ["a", 18, 0, "b", BlockID.brown_sugar_cubes_shell, 0, "c", ItemID.brown_sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.electric_solar, count: 1, data: 0}, ["aaa","cbc","ccc"], ["a", ItemID.purple_sugar_crystals, 0, "b", BlockID.brown_sugar_cubes_shell, 0, "c", ItemID.sugar_cubes, 0]);
Recipes.addShaped({id: BlockID.sugar_storage_1, count: 1, data: 0}, ["ccc","cbc","ccc"], ["b", BlockID.brown_sugar_cubes_shell, 0, "c", ItemID.purple_sugar_crystals, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_cubes_wire, count: 9, data: 0}, ["aaa","cbc","aaa"], ["a", ItemID.brown_sugar_cubes, 0, "b", ItemID.purple_sugar_crystals, 0, "c", ItemID.brown_sugar, 0]);
Recipes.addShaped({id: BlockID.purple_sugar_cubes_wire, count: 9, data: 0}, ["aaa","cbc","aaa"], ["a", ItemID.purple_sugar_cubes, 0, "b", ItemID.purple_sugar_crystals, 0, "c", ItemID.purple_sugar, 0]);
Recipes.addShaped({id: BlockID.brown_sugar_burner, count: 1, data: 0}, ["aaa","cbc","ccc"], ["a", ItemID.brown_sugar_cubes, 0, "b", BlockID.brown_sugar_cubes_shell, 0, "c", 331, 0]);

});




// file: shared.js

ModAPI.registerAPI("SugarRabbit", {
	Music: music,
	MusicArry: mis,
	Core: SugarCore,
	
	requireGlobal: function(command){
		return eval(command);
	}
});

Logger.Log("Granulated Sugar API shared with name SugarRabbit.", "API");




