Recipes.registryCandyRecipe(ItemID.sugar_cubes, 0, ItemID.brown_sugar_cubes, 0);
Recipes.registryCandyRecipe(ItemID.brown_sugar_cubes, 0, ItemID.purple_sugar_cubes, 0);
IDRegistry.genBlockID("brown_sugar_burn");
Block.createBlock("brown_sugar_burn", [{name: "Burn", texture: [["brown_sugar_furnace_top", 0], ["brown_sugar_core_top", 0], ["brown_sugar_furnace_top", 0], ["brown_sugar_furnace_top", 0], ["brown_sugar_furnace_top", 0], ["brown_sugar_furnace_top", 0]], inCreative: true}]);
var BurnGui_sugar = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Burn(Sugar)")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 480, y: 180, bitmap: "arrow_0", scale: 3}, 
        {type: "bitmap", x: 400, y: 180, bitmap: "fire_0", scale: 4}, 
    ],
    elements: {
        "fireScale": {type: "scale", x: 400, y: 180, direction: 1, value: 0.5, bitmap: "fire_1", scale: 4},
        "arrowScale": {type: "scale", x: 480, y: 180, direction: 0, value: 0.5, bitmap: "arrow_1", scale: 3},
        "desert": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {return Recipes.getCandyRecipeResult(id, data) ? true : false}},
        "result": { type: "slot", x: 560, y: 170, size: 60, isValid: function(id, count, data) {return false}},
        "fuel": {type: "slot", x: 400, y: 240, isValid: function(id, count, data) {return Recipes.getFuelBurnDuration(id, data) > 0}, size: 60},
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(BurnGui_sugar, "炼糖炉");
});
TileEntity.registerPrototype(BlockID.brown_sugar_burn, {
    defaultValues: {
        burn: 0,
        burnMax: 200,
        make: 0,
        isCreate: false,
    },
    getFuel: function (Name) {
        var fuelSlot = this.container.getSlot(Name);
        var fuel = Recipes.getFuelBurnDuration(fuelSlot.id, fuelSlot.data);
            if (fuelSlot.id == 325 && fuelSlot.data == 10) {
                fuelSlot.data = 0;
                fuelSlot.count = 1;
            } else {
                fuelSlot.count -= 1;
                this.container.validateSlot(Name);
            };
        return this.data.burnMax = this.data.burn = fuel;
    },
    tick: function() {
        var desert = this.container.getSlot("desert");
        var resultSlot = this.container.getSlot("result");
        var fuelSlot = this.container.getSlot("fuel");
        var result = Recipes.getCandyRecipeResult(desert.id, desert.data);
        if (result && (resultSlot.id == result.id || resultSlot.id == 0) && resultSlot.count < 64 && resultSlot.data == result.data) {
            if (this.data.burn > 0) {
                this.data.isCreate = true;
                this.data.make += 1;
            } else if (fuelSlot.id > 0) {
                this.getFuel("fuel");
            } else {
                this.data.make = 0;
                this.data.isCreate = false;
            };
        };
        if (this.data.burn > 0) {
            this.data.burn -= 1;
        };
        if (this.data.make == 200) {
            resultSlot.id = result.id;
            resultSlot.data = result.data;
            resultSlot.count += 1;
            desert.count -=1;
            this.container.validateSlot("desert");
            this.data.make = 0;
            this.data.isCreate = false;
        };
        if (desert.id == 0) {
            this.data.isCreate = false;
        };
        if (!this.data.isCreate) {
            this.data.make = 0
        };
        if (this.data.burn <= 0 && !this.data.isCreate) {
            this.data.burn = this.data.make = 0;
            this.data.burnMax = 200;
        };
        this.container.setScale("arrowScale", this.data.make / 200);
        this.container.setScale("fireScale", this.data.burn / this.data.burnMax);
    },
    click: function(id, count, data, coords) {
        if (World.getBlock(this.x, this.y - 1, this.z).id == BlockID.sugar_tile && World.getBlock(this.x + 1, this.y - 1, this.z).id == BlockID.brown_sugar_tile && World.getBlock(this.x - 1, this.y - 1, this.z).id == BlockID.brown_sugar_tile && World.getBlock(this.x, this.y - 1, this.z + 1).id == BlockID.brown_sugar_tile && World.getBlock(this.x, this.y - 1, this.z - 1).id == BlockID.brown_sugar_tile) {
            return false;
        } else {
            return true;
        };
    },
    getGuiScreen: function() {
        return BurnGui_sugar;
    },
});
StorageInterface.createInterface(BlockID.brown_sugar_burn, {
	slots: {
		"desert": {input: true,
	         isValidInput: function(item){
		         return Recipes.getCandyRecipeResult(item.id, item.data) ? true : false;
	         }
	     },
	    "fuel": {input: true,
	         isValidInput: function(item){
		         return Recipes.getFuelBurnDuration(item.id, item.data) > 0;
	         }
	     },
	    "result": {input: false}
	 }
});