Recipes.registryBurnerRecipe(ItemID.purple_sugar_crystals, 0, ItemID.core_plate_1, 0);
Recipes.registryBurnerRecipe(ItemID.brown_sugar_plate, 0, ItemID.core_plate_1, 0);
Recipes.registryBurnerRecipe(ItemID.blue_sugar_crystals, 0, ItemID.core_plate_2, 0);
Recipes.registryBurnerRecipe(ItemID.purple_sugar_plate, 0, ItemID.core_plate_2, 0);
IDRegistry.genBlockID("brown_sugar_burner");
Block.createBlock("brown_sugar_burner", [{name: "Burner", texture: [["brown_sugar_pot_side", 0], ["brown_sugar_pot_side", 0], ["burner_side", 0], ["burner_side", 0], ["burner_side", 0], ["burner_side", 0]], inCreative: true}]);
var Burner_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Burner")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 480, y: 180, bitmap: "arrow_0", scale: 3}, 
        {type: "bitmap", x: 400, y: 180, bitmap: "fire_0", scale: 4}, 
    ],
    elements: {
        "arrowScale": {type: "scale", x: 480, y: 180, direction: 0, value: 0.5, bitmap: "arrow_1", scale: 3},
        "desert1": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {return Recipes.getBurnerRecipeResult(id, data) ? true : false}},
        "desert2": {type: "slot", x: 400, y: 180,  value: 0.5, size: 60, isValid: function(id, count, data) {return Recipes.getBurnerRecipeResult(id, data) ? true : false}},
        "result": { type: "slot", x: 560, y: 170, size: 60, isValid: function(id, count, data) {return false}}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Burner_Gui, "刻录机");
});
TileEntity.registerPrototype(BlockID.brown_sugar_burner, {
    defaultValues: {
        make: 0,
        isCreate: false
    },
    tick: function() {
        var desert_1 = this.container.getSlot("desert1");
        var desert_2 = this.container.getSlot("desert2");
        var resultSlot = this.container.getSlot("result");
        var result_1 = Recipes.getBurnerRecipeResult(desert_1.id, desert_1.data);
        var result_2 = Recipes.getBurnerRecipeResult(desert_2.id, desert_2.data);
        if (result_1 && result_2 && desert_1.id != desert_2.id && result_1.id == result_2.id && result_1.id != 0 && (resultSlot.id == result_1.id || resultSlot.id == 0) && resultSlot.count + 1 <= 64) {
            this.data.make +=1;
            this.data.isCreate = true;
            if (this.data.make == 200) {
                desert_1.count -=1;
                desert_2.count -=1;
                resultSlot.id = result_1.id;
                resultSlot.data = result_1.data;
                resultSlot.count +=1;
                this.data.make = 0;
                this.data.isCreate = false;
            };
        };
        if (desert_1.id == 0 || desert_2.id == 0) {
            this.data.isCreate = false;
            this.data.make = 0;
        };
        this.container.setScale("arrowScale", this.data.make / 200);
    },
    click: function(id, count, data, coords) {
        if (World.getBlock(this.x, this.y - 1, this.z).id == BlockID.purple_sugar_table) {
            return false;
        } else {
            return true;
        };
    },
    getGuiScreen: function() {
        return Burner_Gui;
    },
});
StorageInterface.createInterface(BlockID.brown_sugar_burner, {
	slots: {
		"desert1": {input: false},
	    "desert2": {input: false},
	    "result": {input: false}
	 }
});