IDRegistry.genBlockID("brown_sugar_furnace0");
Block.createBlock("brown_sugar_furnace0", [{name: "Furnace",texture: [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_off", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]],inCreative: true}]);
ToolAPI.registerBlockMaterial(BlockID["brown_sugar_furnace0"], "stone");
TileRenderer.setStandartModel(BlockID.brown_sugar_furnace0, [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_off", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]]);
TileRenderer.registerRotationModel(BlockID.brown_sugar_furnace0, 0, [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_off", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]]);
TileRenderer.registerRotationModel(BlockID.brown_sugar_furnace0, 4, [["brown_sugar_furnace_top", 0],["brown_sugar_furnace_top", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_front_on", 0],["brown_sugar_furnace_side", 0],["brown_sugar_furnace_side", 0]]);
TileRenderer.setRotationPlaceFunction(BlockID.brown_sugar_furnace0);
var FurnaceGui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Furnace(Sugar)")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 480, y: 180, bitmap: "arrow_0", scale: 3}, 
        {type: "bitmap", x: 400, y: 180, bitmap: "fire_0", scale: 4}, 
    ],
    elements: {
        "fireScale": {type: "scale", x: 400, y: 180, direction: 1, value: 0.5, bitmap: "fire_1", scale: 4},
        "arrowScale": {type: "scale", x: 480, y: 180, direction: 0, value: 0.5, bitmap: "arrow_1", scale: 3},
        "desert": {type: "slot", x: 400, y: 100, size: 60, isValid: function(id, count, data) {return Recipes.getFurnaceRecipeResult(id, data) ? true : false}},
        "result": { type: "slot", x: 560, y: 170, size: 60,isValid: function(id, count, data) {return false}},
        "fuel": {type: "slot", x: 400, y: 240, isValid: function(id, count, data) {return Recipes.getFuelBurnDuration(id, data) > 0}, size: 60},
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(FurnaceGui, "糖果熔炉");
});
TileEntity.registerPrototype(BlockID.brown_sugar_furnace0, {
    defaultValues: {
        isActive: false,
        burn: 0,
        burnMax: 200,
        make: 0,
        meta: 0,
        isCreate: false,
    },
    getFuel: function(Name) {
        var fuelSlot = this.container.getSlot(Name);
        var fuel = Recipes.getFuelBurnDuration(fuelSlot.id, fuelSlot.data);
        if (fuelSlot.id == 325 && fuelSlot.data == 10) {
                fuelSlot.data = 0;
                fuelSlot.count = 1;
            } else {
                fuelSlot.count -= 1;
                this.container.validateSlot(Name);
            };
        return this.data.burnMax = this.data.burn = fuel;
    },
    tick: function() {
        var desert = this.container.getSlot("desert");
        var resultSlot = this.container.getSlot("result");
        var fuelSlot = this.container.getSlot("fuel");
        var result = Recipes.getFurnaceRecipeResult(desert.id, desert.data);
        if (result && (resultSlot.id == result.id || resultSlot.id == 0) && resultSlot.data == result.data) {
            if (this.data.burn > 0) {
                this.data.isCreate = true;
                this.data.make += 1;
                if (this.data.make == 200) {
                    resultSlot.id = result.id;
                    resultSlot.data = result.data;
                    resultSlot.count += 1;
                    desert.count -=1;
                    this.container.validateSlot("desert");
                    this.data.make = 0;
                    this.data.isCreate = false;
                };
            } else if (fuelSlot.id > 0) {
                this.getFuel("fuel");
            } else {
                this.data.make = 0;
                this.data.isCreate = false;
            };
        };
        if (this.data.burn > 0) {
            this.data.burn -= 1;
        };
        if (desert.id == 0) {
            this.data.isCreate = false;
        };
        if (!this.data.isCreate) {
            this.data.make = 0
        };
        if (this.data.burn <= 0 && !this.data.isCreate) {
            this.data.burn = this.data.make = 0;
            this.data.burnMax = 200;
        };
        this.container.setScale("arrowScale", this.data.make / 200);
        this.container.setScale("fireScale", this.data.burn / this.data.burnMax);
    },
    getGuiScreen: function() {
        return FurnaceGui;
    },
    init: function() {
        TileRenderer.mapAtCoords(this.x, this.y, this.z, this.blockID, this.data.meta + (this.data.isActive ? 4 : 0));
    },
    activate: function() {
        if (!this.data.isActive) {
            this.data.isActive = true;
            TileRenderer.mapAtCoords(this.x, this.y, this.z, this.blockID, this.data.meta + 4);
        }
    },
    deactivate: function() {
        if (this.data.isActive) {
            this.data.isActive = false;
            TileRenderer.mapAtCoords(this.x, this.y, this.z, this.blockID, this.data.meta);
        };
    },
});
StorageInterface.createInterface(BlockID.brown_sugar_furnace0, {
	slots: {
		"desert": {input: true,
	         isValidInput: function(item){
		         return Recipes.getFurnaceRecipeResult(item.id, item.data) ? true : false;
	         }
	     },
	    "fuel": {input: true,
	         isValidInput: function(item){
		         return Recipes.getFuelBurnDuration(item.id, item.data) > 0;
	         }
	     },
	    "result": {input: false}
	 }
});