IDRegistry.genBlockID("electric_fridge");
Block.createBlockWithRotation("electric_fridge", [{name: "Fridge", texture: [["fridge_side", 0], ["fridge_side", 0], ["fridge_side", 0], ["fridge_front", 0], ["fridge_side", 0], ["fridge_side", 0]], inCreative: true}]);
var Electric_Fridge_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Fridge")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 730, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 730 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "textInfo1": {type: "text", x: 842, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 842, y: 172, width: 350, height: 30, text: "2000"},
        "slot1": {type: "slot", x: 441, y: 75},
        "slot2": {type: "slot", x: 501, y: 75},
        "slot3": {type: "slot", x: 561, y: 75},
        "slot4": {type: "slot", x: 621, y: 75},
        
        "slot5": {type: "slot", x: 441, y: 135},
        "slot6": {type: "slot", x: 501, y: 135},
        "slot7": {type: "slot", x: 561, y: 135},
        "slot8": {type: "slot", x: 621, y: 135},
        
        "slot9": {type: "slot", x: 441, y: 195},
        "slot10": {type: "slot", x: 501, y: 195},
        "slot11": {type: "slot", x: 561, y: 195},
        "slot12": {type: "slot", x: 621, y: 195}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Electric_Fridge_Gui, "电冰箱");
});
SugarCore.registerSUMachine(BlockID.electric_fridge, {
    defaultValues: {
        
    },
    getGuiScreen: function() {
        return Electric_Fridge_Gui;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 2000;
    },
    tick: function() {
        var energyStorage = this.getEnergyStorage();
        StorageInterface.checkHoppers(this);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.electric_fridge, 1, 0, extra);
    }
});
Block.registerDropFunction("electric_fridge", function(coords, blockID, blockData, level){
	return [];
});