IDRegistry.genBlockID("electric_natural");
Block.createBlock("electric_natural", [{name: "Electric Natural", texture: [["natural_side", 0], ["natural_top", 0], ["natural_side", 0]], inCreative: true}]);
SugarCore.registerElectricNaturalRecipes(18, 0, 200);
SugarCore.registerElectricNaturalRecipes(18, 1, 200);
SugarCore.registerElectricNaturalRecipes(18, 2, 200);
SugarCore.registerElectricNaturalRecipes(18, 3, 200);
SugarCore.registerElectricNaturalRecipes(161, 0, 200);
SugarCore.registerElectricNaturalRecipes(161, 1, 200);
SugarCore.registerElectricNaturalRecipes(6, 0, 50);
SugarCore.registerElectricNaturalRecipes(6, 1, 50);
SugarCore.registerElectricNaturalRecipes(6, 2, 50);
SugarCore.registerElectricNaturalRecipes(6, 3, 50);
SugarCore.registerElectricNaturalRecipes(6, 4, 50);
SugarCore.registerElectricNaturalRecipes(6, 5, 50);
SugarCore.registerElectricNaturalRecipes(163, 0, 300);
SugarCore.registerElectricNaturalRecipes(338, 0, 350);
var Electric_Natural_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Electric Natural")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 530, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 530 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "slot1": {type: "slot", x: 441, y: 75},
        "textInfo1": {type: "text", x: 642, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 642, y: 172, width: 350, height: 30, text: "2000"}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Electric_Natural_Gui, "生态发电机");
});
SugarCore.registerSUMachine(BlockID.electric_natural, {
    defaultValues: {
        meta: 0,
        abl: 0,
        energy: 0
    },
    getGuiScreen: function() {
        return Electric_Natural_Gui;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 2000;
    },
    tick: function() {
        var desertSlot = this.container.getSlot("slot1");
        var energyStorage = this.getEnergyStorage();
        var energy = SugarCore.getElectricNaturalRecipes(desertSlot.id, desertSlot.data);
        if (energy > 0 && this.data.abl == 0) {
            this.data.abl = energy;
            desertSlot.count -= 1;
            this.container.validateSlot("slot1");
        };
        if (this.data.abl > 0 && this.data.energy + 10 <= energyStorage) {
            this.data.abl -= 10;
            this.data.energy += 10;
        };
        StorageInterface.checkHoppers(this);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    canReceiveEnergy: function(){
        return false;
    },
    isEnergySource: function() {
        return true;
    },
    energyTick: function(type, src){
		var output = Math.min(32, this.data.energy);
		this.data.energy += src.add(output) - output;
	},
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.electric_natural, 1, 0, extra);
    }
});
Block.registerDropFunction("electric_natural", function(coords, blockID, blockData, level){
	return [];
});
StorageInterface.createInterface(BlockID.electric_natural, {
	slots: {
		"slot1": {input: true}
	 }
});