IDRegistry.genBlockID("electric_solar");
Block.createBlock("electric_solar", [{name: "Electric Solar", texture: [["solar_side", 0], ["solar_top", 0], ["solar_side", 0]], inCreative: true}]);

var Electric_Solar_Gui = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Electric Solar")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 530, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 530 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "slot1": {type: "slot", x: 441, y: 75},
        "textInfo1": {type: "text", x: 642, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 642, y: 172, width: 350, height: 30, text: "2000"}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(Electric_Solar_Gui, "太阳能发电机");
});
SugarCore.registerSUMachine(BlockID.electric_solar, {
    defaultValues: {
        meta: 0,
        canSeeSky: false,
        energy: 0
    },
    getGuiScreen: function() {
        return Electric_Solar_Gui;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 2000;
    },
    tick: function() {
        var desertSlot = this.container.getSlot("slot1");
        var energyStorage = this.getEnergyStorage();
        if (GenerationUtils.canSeeSky(this.x, this.y + 1, this.z) && World.getLightLevel(this.x, this.y + 1, this.z) == 15) {
            this.data.canSeeSky = true;
        } else {
            this.data.canSeeSky = false;
        };
        if (this.data.canSeeSky) {
            this.data.energy += 1;
        };
        StorageInterface.checkHoppers(this);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    canReceiveEnergy: function(){
        return false;
    },
    isEnergySource: function(){
        return true;
    },
    energyTick: function(type, src){
		var output = Math.min(32, this.data.energy);
		this.data.energy += src.add(output) - output;
	},
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.electric_solar, 1, 0, extra);
    }
});
Block.registerDropFunction("electric_solar", function(coords, blockID, blockData, level){
	return [];
});
StorageInterface.createInterface(BlockID.electric_solar, {
	slots: {
		"slot1": {input: true}
	 }
});