ChargeItemRegistry.registerExtraItem(ItemID.purple_sugar_crystals, "Su", 20, 1, 1, "storage", true, true);
ChargeItemRegistry.registerExtraItem(ItemID.blue_sugar_crystals, "Su", 200, 1, 1, "storage", true, true);
IDRegistry.genBlockID("sugar_storage_1");
Block.createBlock("sugar_storage_1", [{name: "Sugar Storage level1", texture: [["sugar_storage", 0]], inCreative: true}]);
var sugarStorage_1 = new UI.StandartWindow({
    standart: {
        header: {text: {text: Translation.translate("Sugar Storage level1")}},
        inventory: {standart: true},
        background: {standart: true}
    },
    drawing: [
        {type: "bitmap", x: 530, y: 144, bitmap: "energy_bar_background", scale: 3.2},
    ],
    elements: {
        "energyScale": {type: "scale", x: 530 + 3.2 * 4, y: 144, direction: 0, value: 0.5, bitmap: "energy_bar_scale", scale: 3.2},
        "slot1": {type: "slot", x: 441, y: 75, /*isValid: function(id, data) {if (}*/},
        "slot2": {type: "slot", x: 441, y: 212/*, isValid: MachineRegistry.isValidEUStorage*/},
        "textInfo1": {type: "text", x: 642, y: 142, width: 300, height: 30, text: "0/"},
        "textInfo2": {type: "text", x: 642, y: 172, width: 350, height: 30, text: "50000"}
    }
});
Callback.addCallback("LevelLoaded", function(){
	SugarCore.updateHeader(sugarStorage_1, "一级储能库");
});
SugarCore.registerSUStorage(BlockID.sugar_storage_1, {
    defaultValues: {
        meta: 0
    },
    getGuiScreen: function() {
        return sugarStorage_1;
    },
    getEnergyLevel: function() {
        return 1;
    },
    getEnergyStorage: function() {
        return 50000;
    },
    tick: function() {
        StorageInterface.checkHoppers(this);
        var energyStorage = this.getEnergyStorage();
        this.data.energy += ChargeItemRegistry.getEnergyFrom(this.container.getSlot("slot2"), "Su", energyStorage - this.data.energy, 1);
        this.data.energy -= ChargeItemRegistry.addEnergyTo(this.container.getSlot("slot1"), "Su", this.data.energy, 1);
        this.container.setScale("energyScale", this.data.energy / energyStorage);
        this.container.setText("textInfo1", parseInt(this.data.energy) + "/");
        this.container.setText("textInfo2", energyStorage);
    },
    canReceiveEnergy: function(side, type) {
        return side != this.data.meta;
    },
    canExtractEnergy: function(side, type) {
        return side == this.data.meta;
    },
    destroyBlock: function(coords, player) {
        var extra;
        if (this.data.energy > 0) {
            extra = new ItemExtraData();
            extra.putInt("energy", this.data.energy);
        };
        World.drop(coords.x + .5, coords.y + .5, coords.z + .5, BlockID.sugar_storage_1, 1, 0, extra);
    },
});
Block.registerDropFunction("sugar_storage_1", function(coords, blockID, blockData, level){
	return [];
});
StorageInterface.createInterface(BlockID.sugar_storage_1, {
	slots: {
		"slot1": {input: true},
		"slot2": {input: true}
	 }
});